function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { Entity, Index, JoinColumn, Column, PrimaryColumn, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
import { DriveFile } from "./drive-file.js";
export let Page = class Page {
    id;
    createdAt;
    updatedAt;
    title;
    name;
    summary;
    alignCenter;
    isPublic;
    hideTitleWhenPinned;
    font;
    userId;
    user;
    eyeCatchingImageId;
    eyeCatchingImage;
    content;
    variables;
    script;
    /**
	 * public ... 公開
	 * followers ... フォロワーのみ
	 * specified ... visibleUserIds で指定したユーザーのみ
	 */ visibility;
    visibleUserIds;
    likedCount;
    constructor(data){
        if (data == null) return;
        for (const [k, v] of Object.entries(data)){
            this[k] = v;
        }
    }
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], Page.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the Page."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], Page.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The updated date of the Page."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], Page.prototype, "updatedAt", void 0);
_ts_decorate([
    Column("varchar", {
        length: 256
    }),
    _ts_metadata("design:type", String)
], Page.prototype, "title", void 0);
_ts_decorate([
    Index(),
    Column("varchar", {
        length: 256
    }),
    _ts_metadata("design:type", String)
], Page.prototype, "name", void 0);
_ts_decorate([
    Column("varchar", {
        length: 256,
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Page.prototype, "summary", void 0);
_ts_decorate([
    Column("boolean"),
    _ts_metadata("design:type", Boolean)
], Page.prototype, "alignCenter", void 0);
_ts_decorate([
    Column("boolean"),
    _ts_metadata("design:type", Boolean)
], Page.prototype, "isPublic", void 0);
_ts_decorate([
    Column("boolean", {
        default: false
    }),
    _ts_metadata("design:type", Boolean)
], Page.prototype, "hideTitleWhenPinned", void 0);
_ts_decorate([
    Column("varchar", {
        length: 32
    }),
    _ts_metadata("design:type", String)
], Page.prototype, "font", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The ID of author."
    }),
    _ts_metadata("design:type", Object)
], Page.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Page.prototype, "user", void 0);
_ts_decorate([
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Page.prototype, "eyeCatchingImageId", void 0);
_ts_decorate([
    ManyToOne((type)=>DriveFile, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Page.prototype, "eyeCatchingImage", void 0);
_ts_decorate([
    Column("jsonb", {
        default: []
    }),
    _ts_metadata("design:type", Array)
], Page.prototype, "content", void 0);
_ts_decorate([
    Column("jsonb", {
        default: []
    }),
    _ts_metadata("design:type", Array)
], Page.prototype, "variables", void 0);
_ts_decorate([
    Column("varchar", {
        length: 16384,
        default: ""
    }),
    _ts_metadata("design:type", String)
], Page.prototype, "script", void 0);
_ts_decorate([
    Column("enum", {
        enum: [
            "public",
            "followers",
            "specified"
        ]
    }),
    _ts_metadata("design:type", String)
], Page.prototype, "visibility", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        array: true,
        default: "{}"
    }),
    _ts_metadata("design:type", Array)
], Page.prototype, "visibleUserIds", void 0);
_ts_decorate([
    Column("integer", {
        default: 0
    }),
    _ts_metadata("design:type", Number)
], Page.prototype, "likedCount", void 0);
Page = _ts_decorate([
    Entity(),
    Index([
        "userId",
        "name"
    ], {
        unique: true
    }),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", [
        typeof Partial === "undefined" ? Object : Partial
    ])
], Page);
